Summary: A C program to run all installed ptests
Name: ptest-runner
Version: 2.4.5.1
Release: r0
License: GPL-2.0-or-later
Group: base
Packager: Poky Maintainers <poky@lists.yoctoproject.org>
URL: http://git.yoctoproject.org/cgit/cgit.cgi/ptest-runner2/about/
Source0: ptest-runner-2.4.5.1-r0.tar.xz
BuildRequires: base-files
BuildRequires: base-passwd
BuildRequires: shadow
BuildRequires: shadow-native
BuildRequires: shadow-sysroot
BuildRequires: virtual/libc
BuildRequires: virtual/x86_64-poky-linux-compilerlibs
BuildRequires: virtual/x86_64-poky-linux-gcc
Requires: /bin/sh
Requires: base-files
Requires: base-passwd
Requires: libc.so.6()(64bit)
Requires: libc.so.6(GLIBC_2.14)(64bit)
Requires: libc.so.6(GLIBC_2.2.5)(64bit)
Requires: libc.so.6(GLIBC_2.3)(64bit)
Requires: libc.so.6(GLIBC_2.3.4)(64bit)
Requires: libc.so.6(GLIBC_2.33)(64bit)
Requires: libc.so.6(GLIBC_2.34)(64bit)
Requires: libc.so.6(GLIBC_2.4)(64bit)
Requires: libc.so.6(GLIBC_2.8)(64bit)
Requires: libc.so.6(GLIBC_2.9)(64bit)
Requires: libc6 >= 2.40+git0+efb710034e
Requires: libgcc
Requires: pstree
Requires: rtld(GNU_HASH)
Requires: shadow
Requires(pre): /bin/sh
Requires(pre): base-files
Requires(pre): base-passwd
Requires(pre): libc.so.6()(64bit)
Requires(pre): libc.so.6(GLIBC_2.14)(64bit)
Requires(pre): libc.so.6(GLIBC_2.2.5)(64bit)
Requires(pre): libc.so.6(GLIBC_2.3)(64bit)
Requires(pre): libc.so.6(GLIBC_2.3.4)(64bit)
Requires(pre): libc.so.6(GLIBC_2.33)(64bit)
Requires(pre): libc.so.6(GLIBC_2.34)(64bit)
Requires(pre): libc.so.6(GLIBC_2.4)(64bit)
Requires(pre): libc.so.6(GLIBC_2.8)(64bit)
Requires(pre): libc.so.6(GLIBC_2.9)(64bit)
Requires(pre): libc6 >= 2.40+git0+efb710034e
Requires(pre): libgcc
Requires(pre): pstree
Requires(pre): rtld(GNU_HASH)
Requires(pre): shadow

%description
The ptest-runner2 package installs a ptest-runner program which loops
through all installed ptest test suites and runs them in sequence.

%package -n ptest-runner-src
Summary: A C program to run all installed ptests - Source files
License: GPL-2.0-or-later
Group: devel

%description -n ptest-runner-src
The ptest-runner2 package installs a ptest-runner program which loops
through all installed ptest test suites and runs them in sequence.  This
package contains sources for debugging purposes.

%package -n ptest-runner-dbg
Summary: A C program to run all installed ptests - Debugging files
License: GPL-2.0-or-later
Group: devel
Recommends: glibc-dbg

%description -n ptest-runner-dbg
The ptest-runner2 package installs a ptest-runner program which loops
through all installed ptest test suites and runs them in sequence.  This
package contains ELF symbols and related sources for debugging purposes.

%package -n ptest-runner-staticdev
Summary: A C program to run all installed ptests - Development files (Static Libraries)
License: GPL-2.0-or-later
Group: devel
Requires: ptest-runner-dev = 2.4.5.1-r0

%description -n ptest-runner-staticdev
The ptest-runner2 package installs a ptest-runner program which loops
through all installed ptest test suites and runs them in sequence.  This
package contains static libraries for software development.

%package -n ptest-runner-dev
Summary: A C program to run all installed ptests - Development files
License: GPL-2.0-or-later
Group: devel
Recommends: base-files-dev
Recommends: base-passwd-dev
Recommends: glibc-dev
Recommends: libgcc-dev
Recommends: pstree-dev
Recommends: ptest-runner = 2.4.5.1-r0
Recommends: shadow-dev
Recommends: shadow-sysroot-dev

%description -n ptest-runner-dev
The ptest-runner2 package installs a ptest-runner program which loops
through all installed ptest test suites and runs them in sequence.  This
package contains symbolic links, header files, and related items necessary
for software development.

%package -n ptest-runner-doc
Summary: A C program to run all installed ptests - Documentation files
License: GPL-2.0-or-later
Group: doc

%description -n ptest-runner-doc
The ptest-runner2 package installs a ptest-runner program which loops
through all installed ptest test suites and runs them in sequence.  This
package contains documentation.

%package -n ptest-runner-locale
Summary: A C program to run all installed ptests
License: GPL-2.0-or-later
Group: base

%description -n ptest-runner-locale
The ptest-runner2 package installs a ptest-runner program which loops
through all installed ptest test suites and runs them in sequence.

%pre
# ptest-runner - preinst
#!/bin/sh
set -e
bbnote () {
	echo "NOTE: $*"
}
bbwarn () {
	echo "WARNING: $*"
}
bbfatal () {
	echo "ERROR: $*"
	exit 1
}
perform_groupadd () {
	local rootdir="$1"
	local opts="$2"
	bbnote "ptest-runner: Performing groupadd with [$opts]"
	local groupname=`echo "$opts" | awk '{ print $NF }'`
	local group_exists="`grep "^$groupname:" $rootdir/etc/group || true`"
	if test "x$group_exists" = "x"; then
		eval flock -x $rootdir/etc -c \"$PSEUDO groupadd \$opts\" || true
		group_exists="`grep "^$groupname:" $rootdir/etc/group || true`"
		if test "x$group_exists" = "x"; then
			bbfatal "ptest-runner: groupadd command did not succeed."
		fi
	else
		bbnote "ptest-runner: group $groupname already exists, not re-creating it"
	fi
}
perform_useradd () {
	local rootdir="$1"
	local opts="$2"
	bbnote "ptest-runner: Performing useradd with [$opts]"
	local username=`echo "$opts" | awk '{ print $NF }'`
	local user_exists="`grep "^$username:" $rootdir/etc/passwd || true`"
	if test "x$user_exists" = "x"; then
		eval flock -x $rootdir/etc -c  \"$PSEUDO useradd \$opts\" || true
		user_exists="`grep "^$username:" $rootdir/etc/passwd || true`"
		if test "x$user_exists" = "x"; then
			bbfatal "ptest-runner: useradd command did not succeed."
		fi
	else
		bbnote "ptest-runner: user $username already exists, not re-creating it"
	fi
}
perform_groupmems () {
	local rootdir="$1"
	local opts="$2"
	bbnote "ptest-runner: Performing groupmems with [$opts]"
	local groupname=`echo "$opts" | awk '{ for (i = 1; i < NF; i++) if ($i == "-g" || $i == "--group") print $(i+1) }'`
	local username=`echo "$opts" | awk '{ for (i = 1; i < NF; i++) if ($i == "-a" || $i == "--add") print $(i+1) }'`
	bbnote "ptest-runner: Running groupmems command with group $groupname and user $username"
	local mem_exists="`grep "^$groupname:[^:]*:[^:]*:\([^,]*,\)*$username\(,[^,]*\)*$" $rootdir/etc/group || true`"
	if test "x$mem_exists" = "x"; then
		eval flock -x $rootdir/etc -c \"$PSEUDO groupmems \$opts\" || true
		mem_exists="`grep "^$groupname:[^:]*:[^:]*:\([^,]*,\)*$username\(,[^,]*\)*$" $rootdir/etc/group || true`"
		if test "x$mem_exists" = "x"; then
			bbfatal "ptest-runner: groupmems command did not succeed."
		fi
	else
		bbnote "ptest-runner: group $groupname already contains $username, not re-adding it"
	fi
}
OPT=""
SYSROOT=""

if test "x$D" != "x"; then
	# Installing into a sysroot
	SYSROOT="$D"
	OPT="--root $D"

	# Make sure login.defs is there, this is to make debian package backend work
	# correctly while doing rootfs.
	# The problem here is that if /etc/login.defs is treated as a config file for
	# shadow package, then while performing preinsts for packages that depend on
	# shadow, there might only be /etc/login.def.dpkg-new there in root filesystem.
	if [ ! -e $D/etc/login.defs -a -e $D/etc/login.defs.dpkg-new ]; then
	    cp $D/etc/login.defs.dpkg-new $D/etc/login.defs
	fi

	# user/group lookups should match useradd/groupadd --root
	export PSEUDO_PASSWD="$SYSROOT"
fi

# If we're not doing a special SSTATE/SYSROOT install
# then set the values, otherwise use the environment
if test "x$UA_SYSROOT" = "x"; then
	# Installing onto a target
	# Add groups and users defined only for this package
	GROUPADD_PARAM=""
	USERADD_PARAM="--system --no-create-home --home / --user-group ptest"
	GROUPMEMS_PARAM=""
fi

# Perform group additions first, since user additions may depend
# on these groups existing
if test "x`echo $GROUPADD_PARAM | tr -d '[:space:]'`" != "x"; then
	echo "Running groupadd commands..."
	# Invoke multiple instances of groupadd for parameter lists
	# separated by ';'
	opts=`echo "$GROUPADD_PARAM" | cut -d ';' -f 1 | sed -e 's#[ \t]*$##'`
	remaining=`echo "$GROUPADD_PARAM" | cut -d ';' -f 2- | sed -e 's#[ \t]*$##'`
	while test "x$opts" != "x"; do
		perform_groupadd "$SYSROOT" "$OPT $opts"
		if test "x$opts" = "x$remaining"; then
			break
		fi
		opts=`echo "$remaining" | cut -d ';' -f 1 | sed -e 's#[ \t]*$##'`
		remaining=`echo "$remaining" | cut -d ';' -f 2- | sed -e 's#[ \t]*$##'`
	done
fi

if test "x`echo $USERADD_PARAM | tr -d '[:space:]'`" != "x"; then
	echo "Running useradd commands..."
	# Invoke multiple instances of useradd for parameter lists
	# separated by ';'
	opts=`echo "$USERADD_PARAM" | cut -d ';' -f 1 | sed -e 's#[ \t]*$##'`
	remaining=`echo "$USERADD_PARAM" | cut -d ';' -f 2- | sed -e 's#[ \t]*$##'`
	while test "x$opts" != "x"; do
		perform_useradd "$SYSROOT" "$OPT $opts"
		if test "x$opts" = "x$remaining"; then
			break
		fi
		opts=`echo "$remaining" | cut -d ';' -f 1 | sed -e 's#[ \t]*$##'`
		remaining=`echo "$remaining" | cut -d ';' -f 2- | sed -e 's#[ \t]*$##'`
	done
fi

if test "x`echo $GROUPMEMS_PARAM | tr -d '[:space:]'`" != "x"; then
	echo "Running groupmems commands..."
	# Invoke multiple instances of groupmems for parameter lists
	# separated by ';'
	opts=`echo "$GROUPMEMS_PARAM" | cut -d ';' -f 1 | sed -e 's#[ \t]*$##'`
	remaining=`echo "$GROUPMEMS_PARAM" | cut -d ';' -f 2- | sed -e 's#[ \t]*$##'`
	while test "x$opts" != "x"; do
		perform_groupmems "$SYSROOT" "$OPT $opts"
		if test "x$opts" = "x$remaining"; then
			break
		fi
		opts=`echo "$remaining" | cut -d ';' -f 1 | sed -e 's#[ \t]*$##'`
		remaining=`echo "$remaining" | cut -d ';' -f 2- | sed -e 's#[ \t]*$##'`
	done
fi


%files
%defattr(-,-,-,-)
%attr(755,root,root) %dir "/usr"
%attr(755,root,root) %dir "/usr/bin"
%attr(755,root,root) "/usr/bin/ptest-runner"
%attr(755,root,root) "/usr/bin/ptest-runner-collect-system-data"

%files -n ptest-runner-src
%defattr(-,-,-,-)
%attr(755,root,root) %dir "/usr"
%attr(755,root,root) %dir "/usr/src"
%attr(755,root,root) %dir "/usr/src/debug"
%attr(755,root,root) %dir "/usr/src/debug/ptest-runner"
%attr(755,root,root) %dir "/usr/src/debug/ptest-runner/2.4.5.1"
%attr(644,root,root) "/usr/src/debug/ptest-runner/2.4.5.1/utils.c"
%attr(644,root,root) "/usr/src/debug/ptest-runner/2.4.5.1/ptest_list.c"
%attr(644,root,root) "/usr/src/debug/ptest-runner/2.4.5.1/main.c"
%attr(644,root,root) "/usr/src/debug/ptest-runner/2.4.5.1/utils.h"
%attr(644,root,root) "/usr/src/debug/ptest-runner/2.4.5.1/ptest_list.h"

%files -n ptest-runner-dbg
%defattr(-,-,-,-)
%attr(755,root,root) %dir "/usr"
%attr(755,root,root) %dir "/usr/bin"
%attr(755,root,root) %dir "/usr/bin/.debug"
%attr(755,root,root) "/usr/bin/.debug/ptest-runner"

%files -n ptest-runner-dev
%defattr(-,-,-,-)

%%prep
echo "include logs and patches, Please check them in SOURCES"

